



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdlib.h>
#include <avr/eeprom.h>



#include <portbits.h>
#include "param.h"
#include "global.h"

#include "ds18b20.h"
#include "eeprom.h"


#include "uart.h"
#include "rs485.h"
#include "rfm12b.h"




#define UART_BAUD_RATE		  76800// 250000




//RFM12
// define USE_868 in der rf12.c zum Umschalten zwischen 433 (auskommentiert) und 868MHz (aktiv) verwenden! Bei der 868MHz Version ist die Einhaltung der maximalen Sendedauer bei den einzelnen Kanlen zu beachten!

#define CHANNEL			2			// Sende/Empfangskanal (0-3) (nur gltig wenn kein DIP Schalter verwendet wird)
#define RF_BAUDRATE		4800		// Baudrate des RFM12 (nur gltig wenn kein DIP Schalter verwendet wird)

   char rxbuf[32+1];		// Puffer fr empfangene Daten
   char txbuf[32+1];		// Puffer fr zu sendende Daten

//DS18S20


					    // fr den ROM-Adressen und Scratchboard
  uint8_t  sensor_cnt;					// Anzahl der erfolgreich angelernten Sensoren
   char msg[30];	
  uint8_t  ow_buffer[9];					// fr den ROM-Adressen und Scratchboard

  uint8_t  id[9];					    // fr den ROM-Adressen und Scratchboard


	
volatile unsigned int a = 0;
volatile unsigned int b = 0;
volatile unsigned int light1 = 0;
volatile unsigned int light2 = 0;

volatile unsigned int time1 = 50;
volatile unsigned int time2 = 50;

//volatile unsigned int sollTime1 = 0;
//volatile unsigned int sollTime2 = 0;
volatile unsigned char sollTime1 = 0;
volatile unsigned char sollTime2 = 0;

volatile unsigned char kanal = 0;
volatile unsigned char step  = 10;          //Schrittweite fr nderung pro Tastendruck

volatile unsigned int hunderstelsekunde;
volatile unsigned int dimmzeit = 1000;

volatile unsigned int kanalblinktime;
volatile unsigned int kanalblinkzeit = 9000;


volatile unsigned int prelltime;
volatile unsigned int prellzeit = 1000;


volatile unsigned char K1LEDfl = 0;
volatile unsigned char K2LEDfl = 0;
volatile unsigned char syncfl = 0;



volatile uint8_t key_state;                       // debounced and inverted key state:
                                                  // bit = 1: key pressed
volatile uint8_t key_press;                       // key press detect
 
volatile uint8_t key_rpt;                         // key long press and repeat


 uint8_t device_Adr = 0x02;           // Gerteadresse 
 uint8_t device_ID;  



void port_init(void);

void rfm12b_poll(void);

void rx_packet(void);
void tx_packet(unsigned char retrans);

void DS1820(void);




void port_init( void )
{

//AUSGNGE PORTD
 DDRD =  (1<<K1LED_BIT  ) | (1<<K2LED_BIT  )| (1<<SCK)|(1<<CS)  ;//als ausgang
 
 //DDRD |=  (1<<K1LED_BIT  ) | (1<<K2LED_BIT  ) | (1<<SCK)|(1<<CS) ;//als ausgang
 PORTD = (1<<CS) ;

//AUSGNGE PORTC
 DDRC = (1 << TRIAC2_BIT) | (1<<TRIAC1_BIT  ) | (1<<SYnc_LED_BIT  ) | (1<<ERROR_LED_BIT  )| (1<<SDI)   ;//als ausgang
 //DDRC |= (1 << TRIAC2_BIT) | (1<<TRIAC1_BIT  ) | (1<<SYnc_LED_BIT  ) | (1<<ERROR_LED_BIT  )| (1<<SDI)  ;//als ausgang
 DDRC&=~((1<<SDO));

}



//Taster-Entprellung und Auswertung
//und Kanal-LED Ein-Aus-Schalten
ISR(TIMER2_OVF_vect)
{



  

  prelltime++;
  if(prelltime == prellzeit)
  {
    prelltime = 0;
	syncfl = 0;


	       
  


 
 
}

 
}



//Zero-Cross-Detectin
ISR(INT1_vect)
{
  a = TCNT1;
  b = a/100;
  TCNT1 = 0;
  
  TRIAC1_OFF();
  TRIAC2_OFF();

  syncfl = 1;
  //syncfl= !syncfl;

}


//Lampen-Dimmung und
//Kanal-LED Blink Zeit
ISR(TIMER0_OVF_vect)
{    
  hunderstelsekunde++;
  if(hunderstelsekunde == dimmzeit)
  {
     hunderstelsekunde = 0;
    
   if( time1 < sollTime1 )
     time1++;
    
   else if( time1 > sollTime1 )
     time1--;
    
   if( time2 < sollTime2 )
     time2++;
	
   else if( time2 > sollTime2 )
     time2--;
 
   if (kanal == 1) 
    {
	 light1 = b*time1;
    }
	
   if (kanal == 2) 
    {
	 light2 = b*time2;
    }	
  }

   if ((TCNT1 >= (a - light1)) && (TCNT1 <= (a - light1)+3))
    {
     TRIAC1_ON();
    }
   else
    {
     TRIAC1_OFF();
    }
    
   if ((TCNT1 >= (a - light2)) && (TCNT1 <= (a - light2)+2))
    {
     TRIAC2_ON();
    }
   else
    {
     TRIAC2_OFF();
    }
	



  kanalblinktime++;
  if(kanalblinktime == kanalblinkzeit)
   {
	 kanalblinktime = 0;
     syncfl = 0;

   if (kanal == 1)
    {
     K2LEDfl= 0;        //auf 0  setzen
     K1LEDfl= !K1LEDfl; //Variable mit einem ! ist ein logisches NICHT Toggeln beliebige Zahl ungleich 0    ->  0
    }
  
   if (kanal == 2) 
    {
     K1LEDfl= 0;        //auf 0  setzen
     K2LEDfl= !K2LEDfl; //Variable mit einem ! ist ein logisches NICHT Toggeln beliebige Zahl ungleich 0    ->  0
    }

   if(K1LEDfl == 1)
    {
     K1LED_ON();
    }
   else
    {
     K1LED_OFF();
    }

   if(K2LEDfl == 1)
    {
     K2LED_ON();
    }
   else
    {
     K2LED_OFF();
    } 

  }
  

  
  



    if(syncfl == 1)
    {
     SYnc_LED_OFF();
    }
    else
    {
     SYnc_LED_ON ();
    }
     
   
   
}
 
 
 

 
 
 
 
 
 
 
 

int main(void) __attribute__((OS_main));
int main(void)
{	
	
 cli();
   port_init();
 uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) ); 


	
//*******************
  TCCR2 = (1<<CS00);    // No prescaling
  TCNT2 = 0;//TIMER2 Startwert 

  TCCR0 = (1<<CS00);    // No prescaling 
  TIMSK = (1<<TOIE0)|(1<<TOIE2);
    
  MCUCR = 0b00001100;
  GICR =  0b10000000;
  TCCR1B = 0b00000100;    //Timer1 starten

 sei();
  
  ERROR_LED_ON();
  
//Triacs erstmal Ausschalten  
  TRIAC1_OFF();
  TRIAC2_OFF();
 
//Werksseitige voreingestellte EEpromspeicheradresse und Gerteadresse
 // EEPWriteByte(device_Adr, 55);          // Byte=55 an die Adresse 0x02 schreiben

  device_ID=EEPReadByte(device_Adr);     // Gerteadresse von Adresse 0x02 lesen  



  PORT_UART_OUT &= ~( 1 << PIN_UART_OUT );

 
  rf12_init();									// ein paar Register setzen (z.B. CLK auf 10MHz)
  rf12_config(RF_BAUDRATE, CHANNEL, 0, QUIET);	// Baudrate, Kanal (0-3), Leistung (0=max, 7=min), Umgebungsbedingungen (QUIET, NORMAL, NOISY)
  rf12_rxmode();




  
  
  device_ID=50 ;//EEPReadByte(device_Adr);   // Gerteadresse von Adresse 0x02 lesen 		   
			
  setTransmitMode();												 
  uart_putc(device_ID);				  // device_ID ausgeben 						
  setReceiveMode();		 


  kanal=1;

//mainloop:
 for (;;)
 {


rx_packet();
  }
}



void rx_packet(void)
{  uint8_t  Len;	  
 
  rf12_rxdata_test(rxbuf,3);	

   
   
   if (rxbuf[0] == device_ID)//if (device_ID == rxbuf[0])	
	{
	   K1LED_ON();
       
	   //Dimmen Kanal 1
	   if (rxbuf[1] == Komand_channel_1)				                     //  
	    {
         kanal=1;
         sollTime1=rxbuf[2];
		}
		
	   //Dimmen Kanal 2
	   if (rxbuf[1] == Komand_channel_2)				                     //  
	    {
		 kanal=2;
         sollTime2=rxbuf[2];
        }
	   
	   
	   
	   //Dimm-Daten Abfragen Kanal 1 und 2	
       if (rxbuf[1] == Komand_channel_3)				                     //  
	    {

		 sprintf(msg,"%d,%d,%d",device_ID ,sollTime1, sollTime2);	
		
		 Len = strlen (msg);
		
		 rf12_txdata_TEST(msg,Len);		
		
		} 
        	    
				

		
	    if (rxbuf[1] == DATA_READ)				                     //  
	    {
            kanal=1;
		     DS1820();
          	kanal=2;	
        }		
	}	
		

    else  //Keine daten ber RFM12B
    {
     
    }
	/**/	
rxbuf[0]= 255;	
rxbuf[1]= 255;			
rxbuf[2]= 255;			

}

void tx_packet(unsigned char retrans)
{

}

//########################################
void DS1820(void)
//########################################
{
 uint8_t t;
		      txbuf[0]= 1;
              txbuf[1]= 2;
		      txbuf[2]= 3;			

              ds1820_init(DS1820_pin_po);              //Initialize DS1820 Buffer oben
		      ds1820_read_temp(DS1820_pin_po);
              
			  t = strlen (msg);
		
		      rf12_txdata_TEST(msg,20);

				
}