/*
ds18b20 lib 0x02

copyright (c) Davide Gironi, 2012

Released under GPLv3.
Please refer to LICENSE file for licensing information.

References:
  + Using DS18B20 digital temperature sensor on AVR microcontrollers
    by Gerard Marull Paretas, 2007
    http://teslabs.com/openplayer/docs/docs/other/ds18b20_pre1.pdf
*/


#ifndef DS18B20_H_
#define DS18B20_H_

#include <avr/io.h>
#include <avr/io.h>
#include <math.h>



//-----------------------------------------
// Set Ports
//-----------------------------------------
#define DS1820_pin_po	PB0                //"Puffer oben" sensor #1
#define DS1820_PIN	PINB                   //DS1820 PIN
#define DS1820_PORT	PORTB                  //DS1820 PORT
#define DS1820_DDR	DDRB                   //DS1820 DDR
//-----------------------------------------
// Prototypes
//-----------------------------------------
uint8_t ds1820_reset(uint8_t);
void ds1820_wr_bit(uint8_t,uint8_t);
uint8_t ds1820_re_bit(uint8_t);
uint8_t ds1820_re_byte(uint8_t);
void ds1820_wr_byte(uint8_t,uint8_t);
void ds1820_read_temp(uint8_t);
void  ds1820_init(uint8_t);

void delay_ms(uint16_t time);
void delay_us(uint16_t time);


#endif
