// --- [ eeprom.c ] -----------------------------------------------------------

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <avr/eeprom.h>

#include "eeprom.h"

#include "param.h"

#include "uart.h"





// ----------------------------------------------------------------------------
// Schreibt genau 1 Byte an die angegebene Adresse im Eeprom

void EEPWriteByte(uint16_t addr, uint8_t val)
{
  eeprom_write_byte((uint8_t *)addr, val);
}

// ----------------------------------------------------------------------------
// Liest genau 1 Byte an der angegebenen Adresse aus dem Eeprom
uint8_t EEPReadByte(uint16_t addr)
{
  return eeprom_read_byte((uint8_t *)addr);
}

// -----------------------------------------------------------------------------
// Gibt einen Speicherauszug des Eeproms aus
// in Zeile 1 werden die Variablen Autostart (0/255) und das Messintervall ausgegeben
// ab Zeile 2 folgen die Sensoren
void ee_print_eeprom(void)
{
uint8_t i, j;


for (i = 0; i < EEPROM_SIZE; i += 8)		// Speicherauszug Eeprom drucken
	{
	for(j = 0; j < 8; j++)						// jeweils 8 Byte pro Zeile = 1 Sensor
		{
		//uart_puts(utoa(EEPReadByte(i + j), buffer, 16));
		//uart_putc(' ');
		}
		
	}
}

// --- [ eof ] ----------------------------------------------------------------