// --- [ rs232.c ] -----------------------------------------------------------
// fr Senden und Empfangen via RS232
// Empfangene Daten werden in einen Ringpuffer abgelegt.
// Zu sendende Daten (zum Debuggen) werden direkt pollend ausgegeben.

#include <avr/io.h>

#include "param.h"
#include "rs485.h"



//###################################################################################
void rs485_init( void )
{

DDR_UART_OUT  |= ( 1 << PIN_UART_OUT );
PORT_UART_OUT &= ~( 1 << PIN_UART_OUT );

}
//###############################################################################

//###################################################################################
void setTransmitMode( void )
{

	PORT_UART_OUT |= ( 1 << PIN_UART_OUT );

}
//###################################################################################

//###################################################################################
void setReceiveMode( void )
{
    while ( !( UCSRA & (1<<TXC)) );    // Wait for empty transmit buffer
    UCSRA |= (1<<TXC);                  // clear txc flag

	PORT_UART_OUT &= ~( 1 << PIN_UART_OUT );
}
//###################################################################################