
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "uart.h"
#include "param.h"

//###################################################################################  
 void uart_init(unsigned int baudrate)
//################################################################################### 
{
  UBRRH = (unsigned char)(baudrate>>8);
  UBRRL = (unsigned char) baudrate;
  
  UCSRB |= (1<<TXEN) | (1<<RXEN);
  // Frame Format: Asynchron 8N1
  UCSRC = (1<<URSEL)|(1 << UCSZ1)|(1 << UCSZ0); // Asynchron 8N1
}
//###################################################################################

//###################################################################################
void uart_putc(unsigned char c)
//###################################################################################
{
    while (!(UCSRA & (1<<UDRE)));  /* warten bis Senden moeglich */
    {
    }              
    //{
    UDR = c;
	//}

                          /* sende Zeichen */
}
//###################################################################################

//###################################################################################
uint8_t uart_getc(void)
//###################################################################################
{
    while (!(UCSRA & (1<<RXC)));   // warten bis Zeichen verfuegbar
       
    return UDR;                   // Zeichen aus UDR an Aufrufer zurueckgeben

}
//###################################################################################

//###################################################################################
/* puts ist unabhaengig vom Controllertyp */
void uart_puts(const char *s )
//###################################################################################
{
    while (*s) 
      uart_putc(*s++);
}/* uart_puts */   
//###################################################################################